/*
 * Funkcje realizujce rne operatory matematyczne
 *
 * eval.c v1.2 (17.02.2003) by Marek Szyprowski <marek@amiga.pl>
 *
 * Niniejszy fragment kodu jest czci biblioteki RPN (plik rpn.c)
 *
 
 * Biblioteka RPN jest wolnym oprogramowaniem; moesz go
 * rozprowadza dalej i/lub modyfikowa na warunkach Powszechnej
 * Licencji Publicznej GNU, wydanej przez Fundacj Wolnego
 * Oprogramowania - wedug wersji 2 tej Licencji lub (wedug twojego
 * wyboru) ktrej z pniejszych wersji.
 *
 * Niniejszy program rozpowszechniany jest z nadziej, i bdzie on
 * uyteczny - jednak BEZ JAKIEJKOLWIEK GWARANCJI, nawet domylnej
 * gwarancji PRZYDATNOCI HANDLOWEJ albo PRZYDATNOCI DO OKRELONYCH
 * ZASTOSOWA. W celu uzyskania bliszych informacji signij do
 * Powszechnej Licencji Publicznej GNU.
 *	   
 */

#include <stdio.h>
#include <math.h>

#include "eval.h"

extern double var_x;

double op_minus (double a, double b)
{
	return a - b;
}
double op_plus (double a, double b)
{
	return a + b;
}
double op_mul (double a, double b)
{
	return a * b;
}
double op_div (double a, double b)
{
	return a / b;
}
double op_pow (double a, double b)
{
	return pow(a,b);
}
double op_sqrt(double a, double b)
{
	return sqrt(a);
}

double op_sgn(double a, double b)
{
	if (a>0) return 1;
	else if (a==0) return 0;
	else return -1;
}

double op_pp(double a, double b)
{
    return (a - (double)((int)a)); 
}

double op_int(double a, double b)
{
    if (a<0)  
		return ((double)(int)a-1);
    else 
		return ((double)(int)a);
}
#ifndef __MINGW32__
double op_cbrt(double a, double b)
{
	return cbrt(a);
}
#endif
double op_abs(double a, double b)
{
	return fabs(a);
}
double op_ln(double a, double b)
{
	return log(a);
}
double op_sin (double a, double b)
{
	return sin(a);
}
double op_cos (double a, double b)
{
	return cos(a);
}
double op_tan (double a, double b)
{
	return tan(a);
}
double op_arcsin (double a, double b)
{
	return asin(a);
}
double op_arccos (double a, double b)
{
	return acos(a);
}
double op_arctan (double a, double b)
{
	return atan(a);
}

double op_ctg (double a, double b)
{
	return (cos(a)/sin(a));
}

double op_pi ()
{
	return M_PI;
}
double op_e ()
{
	return M_E;
}
double op_x ()
{
	return var_x;
}

struct op operators[] = { 
	{1, 2, "-", op_minus},
	{1, 2, "+", op_plus},
	{2, 2, "*", op_mul},
	{2, 2, "/", op_div},
	{3, 2, "^", op_pow},
	{4, 1, "sqrt", op_sqrt},
	{4, 1, "sgn", op_sgn},
	{4, 1, "pp" ,op_pp},
	{4, 1, "int" ,op_int},
#ifndef __MINGW32__
	{4, 1, "cbrt", op_cbrt},
#endif
	{4, 1, "abs", op_abs},
	{4, 1, "ln", op_ln},
	{4, 1, "sin", op_sin},
	{4, 1, "cos", op_cos},
	{4, 1, "tg", op_tan},
	{4, 1, "arcsin", op_arcsin},
	{4, 1, "arccos", op_arccos},
	{4, 1, "arctg", op_arctan},
	{4, 1, "ctg" ,op_ctg},
	{0, 0, "pi", op_pi},
	{0, 0, "e", op_e},
	{0, 0, "x", op_x},
	{0, 0, NULL, NULL}
};
